<template>
  <div class="overflow-x-auto">
    <div
      role="tablist"
      class="flex flex-row items-end justify-start gap-2 border-b-2 border-b-ec-neutral-60"
    >
      <a
        v-for="tab in tabs"
        @click="activeTab = tab.tabName"
        class="translate-y-0.5 whitespace-nowrap border-b-2 border-b-transparent px-4 py-2"
        :class="{ '!border-b-ec-primary font-bold': activeTab === tab.tabName }"
        :href="`#${tab.tabName}`"
        :aria-selected="activeTab === tab.tabName"
        role="tab"
      >
        {{ tab.tabTitle }}
      </a>
    </div>
  </div>
  <div>
    <div
      v-for="tab in tabs"
      :class="{
        block: activeTab === tab.tabName,
        hidden: activeTab !== tab.tabName,
      }"
      class="pt-4"
    >
      <p class="hidden">{{ tab.tabTitle }}</p>
      <slot :name="tab.tabName" />
    </div>
  </div>
</template>

<script setup lang="ts">
import { onBeforeMount, ref, type PropType } from 'vue';

export interface STabProps {
  tabName: string;
  tabTitle: string;
}

const props = defineProps({
  tabs: {
    type: Array as PropType<STabProps[]>,
    required: true,
  },
});

const isHashATab = (hash: string) => props.tabs.some((tab) => tab.tabName === hash.slice(1));

const activeTab = ref(props.tabs[0].tabName);

onBeforeMount(() => {
  if (window?.location?.hash) {
    if (isHashATab(window.location.hash)) {
      activeTab.value = window.location.hash.slice(1);
    }
  }
});
</script>
